import java.util.Iterator;
import java.util.NoSuchElementException;

class PreorderIterator<V> implements Iterator<V> {
  private Tree<V> current;
  // contient le prochain noeud du parcours

  public PreorderIterator(Tree<V> t) {
    current = t;
  }

  public boolean hasNext() {
    return current != null;
  }

  public V next() {
    if (!hasNext()) throw new NoSuchElementException();
    // la valeur à renvoyer est donnée par current
    V v = current.val;
    // il faut maintenant mettre current à jour
    if (current.left != null)
      // s'il existe un sous-arbre gauche, on y passe
      current = current.left;
    else if (current.right != null)
      // sinon, s'il existe un sous-arbre droit, on y passe
      current = current.right;
    else {
      // sinon, il faut remonter
      // c'est ici plus compliqué que pour le parcours infixe
      while(true) {
        // comme pour le parcours infixe, on remonte les sous-arbres droits
        while (current.parent != null && current == current.parent.right)
          current = current.parent;
        current = current.parent;
        // si on est arrivé tout en haut, c'est terminé
        if (current == null) break;
        // si le sous-arbre droit existe, on y va et c'est terminé
        if (current.right != null) { current = current.right; break; }
        // sinon, on continue à remonter
      }
    }
    return v;
  }
}
