import java.util.Iterator;

public class Tree<V> implements Iterable<V> {

  V val;
  Tree<V> left, right;
  Tree<V> parent;

  public Tree(V val, Tree<V> left, Tree<V> right){
    this.val = val;
    this.left = left;
    this.right = right;
    this.parent = null;
    // ne pas oublier de mettre parent à jour pour les sous-arbres
    if (left != null) left.parent = this;
    if (right != null) right.parent = this;
  }

  // par défaut, parcours in-order
  public Iterator<V> iterator() {
    return inorderIterator();
  }

  public Iterator<V> inorderIterator() {
    return new InorderIterator<V>(this);
  }

  public Iterator<V> preorderIterator() {
    return new PreorderIterator<V>(this);
  }

}
